Index: lemon/dijkstra.h
===================================================================
--- lemon/dijkstra.h	(revision 317)
+++ lemon/dijkstra.h	(revision 220)
@@ -767,14 +740,14 @@
     }
 
-    ///Runs the algorithm from the given source node.
-
-    ///This method runs the %Dijkstra algorithm from node \c s
-    ///in order to compute the shortest path to each node.
-    ///
-    ///The algorithm computes
-    ///- the shortest path tree,
-    ///- the distance of each node from the root.
-    ///
-    ///\note <tt>d.run(s)</tt> is just a shortcut of the following code.
+    ///Runs %Dijkstra algorithm from node \c s.
+
+    ///This method runs the %Dijkstra algorithm from a root node \c s
+    ///in order to
+    ///compute the
+    ///shortest path to each node. The algorithm computes
+    ///- The shortest path tree.
+    ///- The distance of each node from the root.
+    ///
+    ///\note d.run(s) is just a shortcut of the following code.
     ///\code
     ///  d.init();
@@ -790,12 +763,10 @@
     ///Finds the shortest path between \c s and \c t.
 
-    ///This method runs the %Dijkstra algorithm from node \c s
-    ///in order to compute the shortest path to node \c t
-    ///(it stops searching when \c t is processed).
-    ///
-    ///\return \c true if \c t is reachable form \c s.
-    ///
-    ///\note Apart from the return value, <tt>d.run(s,t)</tt> is just a
-    ///shortcut of the following code.
+    ///Finds the shortest path between \c s and \c t.
+    ///
+    ///\return The length of the shortest s---t path if there exists one,
+    ///0 otherwise.
+    ///\note Apart from the return value, d.run(s) is
+    ///just a shortcut of the following code.
     ///\code
     ///  d.init();
@@ -803,9 +774,9 @@
     ///  d.start(t);
     ///\endcode
-    bool run(Node s,Node t) {
+    Value run(Node s,Node t) {
       init();
       addSource(s);
       start(t);
-      return (*_heap_cross_ref)[t] == Heap::POST_HEAP;
+      return (*_pred)[t]==INVALID?OperationTraits::zero():(*_dist)[t];
     }
 
@@ -815,87 +786,75 @@
     ///The result of the %Dijkstra algorithm can be obtained using these
     ///functions.\n
-    ///Either \ref lemon::Dijkstra::run() "run()" or
-    ///\ref lemon::Dijkstra::start() "start()" must be called before
-    ///using them.
+    ///Before the use of these functions,
+    ///either run() or start() must be called.
 
     ///@{
 
-    ///The shortest path to a node.
-
-    ///Returns the shortest path to a node.
-    ///
-    ///\warning \c t should be reachable from the root(s).
-    ///
-    ///\pre Either \ref run() or \ref start() must be called before
-    ///using this function.
-    Path path(Node t) const { return Path(*G, *_pred, t); }
-
-    ///The distance of a node from the root(s).
-
-    ///Returns the distance of a node from the root(s).
-    ///
-    ///\warning If node \c v is not reachable from the root(s), then
-    ///the return value of this function is undefined.
-    ///
-    ///\pre Either \ref run() or \ref start() must be called before
-    ///using this function.
+    ///Gives back the shortest path.
+
+    ///Gives back the shortest path.
+    ///\pre The \c t should be reachable from the source.
+    Path path(Node t)
+    {
+      return Path(*G, *_pred, t);
+    }
+
+    ///The distance of a node from the root.
+
+    ///Returns the distance of a node from the root.
+    ///\pre \ref run() must be called before using this function.
+    ///\warning If node \c v in unreachable from the root the return value
+    ///of this funcion is undefined.
     Value dist(Node v) const { return (*_dist)[v]; }
 
-    ///Returns the 'previous arc' of the shortest path tree for a node.
-
-    ///This function returns the 'previous arc' of the shortest path
-    ///tree for the node \c v, i.e. it returns the last arc of a
-    ///shortest path from the root(s) to \c v. It is \c INVALID if \c v
-    ///is not reachable from the root(s) or if \c v is a root.
-    ///
-    ///The shortest path tree used here is equal to the shortest path
-    ///tree used in \ref predNode().
-    ///
-    ///\pre Either \ref run() or \ref start() must be called before
-    ///using this function.
+    ///The current distance of a node from the root.
+
+    ///Returns the current distance of a node from the root.
+    ///It may be decreased in the following processes.
+    ///\pre \c node should be reached but not processed
+    Value currentDist(Node v) const { return (*_heap)[v]; }
+
+    ///Returns the 'previous arc' of the shortest path tree.
+
+    ///For a node \c v it returns the 'previous arc' of the shortest path tree,
+    ///i.e. it returns the last arc of a shortest path from the root to \c
+    ///v. It is \ref INVALID
+    ///if \c v is unreachable from the root or if \c v=s. The
+    ///shortest path tree used here is equal to the shortest path tree used in
+    ///\ref predNode().  \pre \ref run() must be called before using
+    ///this function.
     Arc predArc(Node v) const { return (*_pred)[v]; }
 
-    ///Returns the 'previous node' of the shortest path tree for a node.
-
-    ///This function returns the 'previous node' of the shortest path
-    ///tree for the node \c v, i.e. it returns the last but one node
-    ///from a shortest path from the root(s) to \c v. It is \c INVALID
-    ///if \c v is not reachable from the root(s) or if \c v is a root.
-    ///
-    ///The shortest path tree used here is equal to the shortest path
-    ///tree used in \ref predArc().
-    ///
-    ///\pre Either \ref run() or \ref start() must be called before
+    ///Returns the 'previous node' of the shortest path tree.
+
+    ///For a node \c v it returns the 'previous node' of the shortest path tree,
+    ///i.e. it returns the last but one node from a shortest path from the
+    ///root to \c /v. It is INVALID if \c v is unreachable from the root or if
+    ///\c v=s. The shortest path tree used here is equal to the shortest path
+    ///tree used in \ref predArc().  \pre \ref run() must be called before
     ///using this function.
     Node predNode(Node v) const { return (*_pred)[v]==INVALID ? INVALID:
                                   G->source((*_pred)[v]); }
 
-    ///\brief Returns a const reference to the node map that stores the
-    ///distances of the nodes.
-    ///
-    ///Returns a const reference to the node map that stores the distances
-    ///of the nodes calculated by the algorithm.
-    ///
-    ///\pre Either \ref run() or \ref init()
-    ///must be called before using this function.
+    ///Returns a reference to the NodeMap of distances.
+
+    ///Returns a reference to the NodeMap of distances. \pre \ref run() must
+    ///be called before using this function.
     const DistMap &distMap() const { return *_dist;}
 
-    ///\brief Returns a const reference to the node map that stores the
-    ///predecessor arcs.
-    ///
-    ///Returns a const reference to the node map that stores the predecessor
-    ///arcs, which form the shortest path tree.
-    ///
-    ///\pre Either \ref run() or \ref init()
-    ///must be called before using this function.
+    ///Returns a reference to the shortest path tree map.
+
+    ///Returns a reference to the NodeMap of the arcs of the
+    ///shortest path tree.
+    ///\pre \ref run() must be called before using this function.
     const PredMap &predMap() const { return *_pred;}
 
-    ///Checks if a node is reachable from the root(s).
-
-    ///Returns \c true if \c v is reachable from the root(s).
-    ///\pre Either \ref run() or \ref start()
-    ///must be called before using this function.
-    bool reached(Node v) const { return (*_heap_cross_ref)[v] !=
-                                        Heap::PRE_HEAP; }
+    ///Checks if a node is reachable from the root.
+
+    ///Returns \c true if \c v is reachable from the root.
+    ///\warning The source nodes are inditated as unreached.
+    ///\pre \ref run() must be called before using this function.
+    ///
+    bool reached(Node v) { return (*_heap_cross_ref)[v] != Heap::PRE_HEAP; }
 
     ///Checks if a node is processed.
@@ -903,19 +862,7 @@
     ///Returns \c true if \c v is processed, i.e. the shortest
     ///path to \c v has already found.
-    ///\pre Either \ref run() or \ref init()
-    ///must be called before using this function.
-    bool processed(Node v) const { return (*_heap_cross_ref)[v] ==
-                                          Heap::POST_HEAP; }
-
-    ///The current distance of a node from the root(s).
-
-    ///Returns the current distance of a node from the root(s).
-    ///It may be decreased in the following processes.
-    ///\pre Either \ref run() or \ref init()
-    ///must be called before using this function and
-    ///node \c v must be reached but not necessarily processed.
-    Value currentDist(Node v) const {
-      return processed(v) ? (*_dist)[v] : (*_heap)[v];
-    }
+    ///\pre \ref run() must be called before using this function.
+    ///
+    bool processed(Node v) { return (*_heap_cross_ref)[v] == Heap::POST_HEAP; }
 
     ///@}
@@ -923,13 +870,16 @@
 
 
-  ///Default traits class of dijkstra() function.
-
-  ///Default traits class of dijkstra() function.
-  ///\tparam GR The type of the digraph.
-  ///\tparam LM The type of the length map.
+
+
+
+  ///Default traits class of Dijkstra function.
+
+  ///Default traits class of Dijkstra function.
+  ///\tparam GR Digraph type.
+  ///\tparam LM Type of length map.
   template<class GR, class LM>
   struct DijkstraWizardDefaultTraits
   {
-    ///The type of the digraph the algorithm runs on.
+    ///The digraph type the algorithm runs on.
     typedef GR Digraph;
     ///The type of the map that stores the arc lengths.
@@ -938,166 +888,178 @@
     ///It must meet the \ref concepts::ReadMap "ReadMap" concept.
     typedef LM LengthMap;
-    ///The type of the length of the arcs.
+    //The type of the length of the arcs.
     typedef typename LM::Value Value;
-
     /// Operation traits for Dijkstra algorithm.
 
-    /// This class defines the operations that are used in the algorithm.
+    /// It defines the used operation by the algorithm.
     /// \see DijkstraDefaultOperationTraits
     typedef DijkstraDefaultOperationTraits<Value> OperationTraits;
-
-    /// The cross reference type used by the heap.
-
-    /// The cross reference type used by the heap.
+    ///The heap type used by Dijkstra algorithm.
+
+    /// The cross reference type used by heap.
+
+    /// The cross reference type used by heap.
     /// Usually it is \c Digraph::NodeMap<int>.
     typedef typename Digraph::template NodeMap<int> HeapCrossRef;
-    ///Instantiates a \ref HeapCrossRef.
+    ///Instantiates a HeapCrossRef.
 
     ///This function instantiates a \ref HeapCrossRef.
-    /// \param g is the digraph, to which we would like to define the
+    /// \param G is the digraph, to which we would like to define the
     /// HeapCrossRef.
-    static HeapCrossRef *createHeapCrossRef(const Digraph &g)
-    {
-      return new HeapCrossRef(g);
-    }
-
-    ///The heap type used by the Dijkstra algorithm.
-
-    ///The heap type used by the Dijkstra algorithm.
+    /// \todo The digraph alone may be insufficient for the initialization
+    static HeapCrossRef *createHeapCrossRef(const GR &G)
+    {
+      return new HeapCrossRef(G);
+    }
+
+    ///The heap type used by Dijkstra algorithm.
+
+    ///The heap type used by Dijkstra algorithm.
     ///
     ///\sa BinHeap
     ///\sa Dijkstra
-    typedef BinHeap<Value, typename Digraph::template NodeMap<int>,
+    typedef BinHeap<typename LM::Value, typename GR::template NodeMap<int>,
                     std::less<Value> > Heap;
 
-    ///Instantiates a \ref Heap.
-
-    ///This function instantiates a \ref Heap.
-    /// \param r is the HeapCrossRef which is used.
-    static Heap *createHeap(HeapCrossRef& r)
-    {
-      return new Heap(r);
-    }
-
-    ///\brief The type of the map that stores the predecessor
+    static Heap *createHeap(HeapCrossRef& R)
+    {
+      return new Heap(R);
+    }
+
+    ///\brief The type of the map that stores the last
     ///arcs of the shortest paths.
     ///
-    ///The type of the map that stores the predecessor
+    ///The type of the map that stores the last
     ///arcs of the shortest paths.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    typedef typename Digraph::template NodeMap<typename Digraph::Arc> PredMap;
+    ///
+    typedef NullMap <typename GR::Node,typename GR::Arc> PredMap;
     ///Instantiates a PredMap.
 
-    ///This function instantiates a PredMap.
-    ///\param g is the digraph, to which we would like to define the
-    ///PredMap.
-    static PredMap *createPredMap(const Digraph &g)
-    {
-      return new PredMap(g);
-    }
-
-    ///The type of the map that indicates which nodes are processed.
-
-    ///The type of the map that indicates which nodes are processed.
+    ///This function instantiates a \ref PredMap.
+    ///\param g is the digraph, to which we would like to define the PredMap.
+    ///\todo The digraph alone may be insufficient for the initialization
+#ifdef DOXYGEN
+    static PredMap *createPredMap(const GR &g)
+#else
+    static PredMap *createPredMap(const GR &)
+#endif
+    {
+      return new PredMap();
+    }
+    ///The type of the map that stores whether a nodes is processed.
+
+    ///The type of the map that stores whether a nodes is processed.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
     ///By default it is a NullMap.
+    ///\todo If it is set to a real map,
+    ///Dijkstra::processed() should read this.
+    ///\todo named parameter to set this type, function to read and write.
     typedef NullMap<typename Digraph::Node,bool> ProcessedMap;
     ///Instantiates a ProcessedMap.
 
-    ///This function instantiates a ProcessedMap.
+    ///This function instantiates a \ref ProcessedMap.
     ///\param g is the digraph, to which
-    ///we would like to define the ProcessedMap.
+    ///we would like to define the \ref ProcessedMap
 #ifdef DOXYGEN
-    static ProcessedMap *createProcessedMap(const Digraph &g)
+    static ProcessedMap *createProcessedMap(const GR &g)
 #else
-    static ProcessedMap *createProcessedMap(const Digraph &)
+    static ProcessedMap *createProcessedMap(const GR &)
 #endif
     {
       return new ProcessedMap();
     }
-
-    ///The type of the map that stores the distances of the nodes.
-
-    ///The type of the map that stores the distances of the nodes.
+    ///The type of the map that stores the dists of the nodes.
+
+    ///The type of the map that stores the dists of the nodes.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    typedef typename Digraph::template NodeMap<typename LM::Value> DistMap;
+    ///
+    typedef NullMap<typename Digraph::Node,typename LM::Value> DistMap;
     ///Instantiates a DistMap.
 
-    ///This function instantiates a DistMap.
+    ///This function instantiates a \ref DistMap.
     ///\param g is the digraph, to which we would like to define
-    ///the DistMap
-    static DistMap *createDistMap(const Digraph &g)
-    {
-      return new DistMap(g);
-    }
-
-    ///The type of the shortest paths.
-
-    ///The type of the shortest paths.
-    ///It must meet the \ref concepts::Path "Path" concept.
-    typedef lemon::Path<Digraph> Path;
+    ///the \ref DistMap
+#ifdef DOXYGEN
+    static DistMap *createDistMap(const GR &g)
+#else
+    static DistMap *createDistMap(const GR &)
+#endif
+    {
+      return new DistMap();
+    }
   };
 
-  /// Default traits class used by DijkstraWizard
+  /// Default traits used by \ref DijkstraWizard
 
   /// To make it easier to use Dijkstra algorithm
-  /// we have created a wizard class.
+  ///we have created a wizard class.
   /// This \ref DijkstraWizard class needs default traits,
-  /// as well as the \ref Dijkstra class.
+  ///as well as the \ref Dijkstra class.
   /// The \ref DijkstraWizardBase is a class to be the default traits of the
   /// \ref DijkstraWizard class.
+  /// \todo More named parameters are required...
   template<class GR,class LM>
   class DijkstraWizardBase : public DijkstraWizardDefaultTraits<GR,LM>
   {
+
     typedef DijkstraWizardDefaultTraits<GR,LM> Base;
   protected:
-    //The type of the nodes in the digraph.
+    /// Type of the nodes in the digraph.
     typedef typename Base::Digraph::Node Node;
 
-    //Pointer to the digraph the algorithm runs on.
+    /// Pointer to the underlying digraph.
     void *_g;
-    //Pointer to the length map.
+    /// Pointer to the length map
     void *_length;
-    //Pointer to the map of processed nodes.
-    void *_processed;
-    //Pointer to the map of predecessors arcs.
+    ///Pointer to the map of predecessors arcs.
     void *_pred;
-    //Pointer to the map of distances.
+    ///Pointer to the map of distances.
     void *_dist;
-    //Pointer to the shortest path to the target node.
-    void *_path;
-    //Pointer to the distance of the target node.
-    void *_di;
-
-  public:
+    ///Pointer to the source node.
+    Node _source;
+
+    public:
     /// Constructor.
 
     /// This constructor does not require parameters, therefore it initiates
-    /// all of the attributes to \c 0.
-    DijkstraWizardBase() : _g(0), _length(0), _processed(0), _pred(0),
-                           _dist(0), _path(0), _di(0) {}
+    /// all of the attributes to default values (0, INVALID).
+    DijkstraWizardBase() : _g(0), _length(0), _pred(0),
+                           _dist(0), _source(INVALID) {}
 
     /// Constructor.
 
-    /// This constructor requires two parameters,
-    /// others are initiated to \c 0.
-    /// \param g The digraph the algorithm runs on.
-    /// \param l The length map.
-    DijkstraWizardBase(const GR &g,const LM &l) :
+    /// This constructor requires some parameters,
+    /// listed in the parameters list.
+    /// Others are initiated to 0.
+    /// \param g is the initial value of  \ref _g
+    /// \param l is the initial value of  \ref _length
+    /// \param s is the initial value of  \ref _source
+    DijkstraWizardBase(const GR &g,const LM &l, Node s=INVALID) :
       _g(reinterpret_cast<void*>(const_cast<GR*>(&g))),
       _length(reinterpret_cast<void*>(const_cast<LM*>(&l))),
-      _processed(0), _pred(0), _dist(0), _path(0), _di(0) {}
+      _pred(0), _dist(0), _source(s) {}
 
   };
 
-  /// Auxiliary class for the function-type interface of Dijkstra algorithm.
-
-  /// This auxiliary class is created to implement the
-  /// \ref dijkstra() "function-type interface" of \ref Dijkstra algorithm.
-  /// It does not have own \ref run() method, it uses the functions
-  /// and features of the plain \ref Dijkstra.
+  /// A class to make the usage of Dijkstra algorithm easier
+
+  /// This class is created to make it easier to use Dijkstra algorithm.
+  /// It uses the functions and features of the plain \ref Dijkstra,
+  /// but it is much simpler to use it.
   ///
-  /// This class should only be used through the \ref dijkstra() function,
-  /// which makes it easier to use the algorithm.
+  /// Simplicity means that the way to change the types defined
+  /// in the traits class is based on functions that returns the new class
+  /// and not on templatable built-in classes.
+  /// When using the plain \ref Dijkstra
+  /// the new class with the modified type comes from
+  /// the original class by using the ::
+  /// operator. In the case of \ref DijkstraWizard only
+  /// a function have to be called and it will
+  /// return the needed class.
+  ///
+  /// It does not have own \ref run method. When its \ref run method is called
+  /// it initiates a plain \ref Dijkstra class, and calls the \ref
+  /// Dijkstra::run method of it.
   template<class TR>
   class DijkstraWizard : public TR
@@ -1105,10 +1067,13 @@
     typedef TR Base;
 
-    ///The type of the digraph the algorithm runs on.
+    ///The type of the underlying digraph.
     typedef typename TR::Digraph Digraph;
-
+    //\e
     typedef typename Digraph::Node Node;
+    //\e
     typedef typename Digraph::NodeIt NodeIt;
+    //\e
     typedef typename Digraph::Arc Arc;
+    //\e
     typedef typename Digraph::OutArcIt OutArcIt;
 
@@ -1117,18 +1082,12 @@
     ///The type of the length of the arcs.
     typedef typename LengthMap::Value Value;
-    ///\brief The type of the map that stores the predecessor
+    ///\brief The type of the map that stores the last
     ///arcs of the shortest paths.
     typedef typename TR::PredMap PredMap;
-    ///The type of the map that stores the distances of the nodes.
+    ///The type of the map that stores the dists of the nodes.
     typedef typename TR::DistMap DistMap;
-    ///The type of the map that indicates which nodes are processed.
-    typedef typename TR::ProcessedMap ProcessedMap;
-    ///The type of the shortest paths
-    typedef typename TR::Path Path;
     ///The heap type used by the dijkstra algorithm.
     typedef typename TR::Heap Heap;
-
   public:
-
     /// Constructor.
     DijkstraWizard() : TR() {}
@@ -1138,8 +1097,6 @@
     /// Constructor that requires parameters.
     /// These parameters will be the default values for the traits class.
-    /// \param g The digraph the algorithm runs on.
-    /// \param l The length map.
-    DijkstraWizard(const Digraph &g, const LengthMap &l) :
-      TR(g,l) {}
+    DijkstraWizard(const Digraph &g,const LengthMap &l, Node s=INVALID) :
+      TR(g,l,s) {}
 
     ///Copy constructor
@@ -1148,127 +1105,76 @@
     ~DijkstraWizard() {}
 
-    ///Runs Dijkstra algorithm from the given source node.
-
-    ///This method runs %Dijkstra algorithm from the given source node
-    ///in order to compute the shortest path to each node.
+    ///Runs Dijkstra algorithm from a given node.
+
+    ///Runs Dijkstra algorithm from a given node.
+    ///The node can be given by the \ref source function.
+    void run()
+    {
+      if(Base::_source==INVALID) throw UninitializedParameter();
+      Dijkstra<Digraph,LengthMap,TR>
+        dij(*reinterpret_cast<const Digraph*>(Base::_g),
+            *reinterpret_cast<const LengthMap*>(Base::_length));
+      if(Base::_pred) dij.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
+      if(Base::_dist) dij.distMap(*reinterpret_cast<DistMap*>(Base::_dist));
+      dij.run(Base::_source);
+    }
+
+    ///Runs Dijkstra algorithm from the given node.
+
+    ///Runs Dijkstra algorithm from the given node.
+    ///\param s is the given source.
     void run(Node s)
     {
-      Dijkstra<Digraph,LengthMap,TR>
-        dijk(*reinterpret_cast<const Digraph*>(Base::_g),
-             *reinterpret_cast<const LengthMap*>(Base::_length));
-      if (Base::_pred)
-        dijk.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
-      if (Base::_dist)
-        dijk.distMap(*reinterpret_cast<DistMap*>(Base::_dist));
-      if (Base::_processed)
-        dijk.processedMap(*reinterpret_cast<ProcessedMap*>(Base::_processed));
-      dijk.run(s);
-    }
-
-    ///Finds the shortest path between \c s and \c t.
-
-    ///This method runs the %Dijkstra algorithm from node \c s
-    ///in order to compute the shortest path to node \c t
-    ///(it stops searching when \c t is processed).
-    ///
-    ///\return \c true if \c t is reachable form \c s.
-    bool run(Node s, Node t)
-    {
-      Dijkstra<Digraph,LengthMap,TR>
-        dijk(*reinterpret_cast<const Digraph*>(Base::_g),
-             *reinterpret_cast<const LengthMap*>(Base::_length));
-      if (Base::_pred)
-        dijk.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
-      if (Base::_dist)
-        dijk.distMap(*reinterpret_cast<DistMap*>(Base::_dist));
-      if (Base::_processed)
-        dijk.processedMap(*reinterpret_cast<ProcessedMap*>(Base::_processed));
-      dijk.run(s,t);
-      if (Base::_path)
-        *reinterpret_cast<Path*>(Base::_path) = dijk.path(t);
-      if (Base::_di)
-        *reinterpret_cast<Value*>(Base::_di) = dijk.dist(t);
-      return dijk.reached(t);
+      Base::_source=s;
+      run();
     }
 
     template<class T>
-    struct SetPredMapBase : public Base {
+    struct DefPredMapBase : public Base {
       typedef T PredMap;
       static PredMap *createPredMap(const Digraph &) { return 0; };
-      SetPredMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting PredMap object.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for setting PredMap object.
+      DefPredMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting PredMap type
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting PredMap type
+    ///
     template<class T>
-    DijkstraWizard<SetPredMapBase<T> > predMap(const T &t)
+    DijkstraWizard<DefPredMapBase<T> > predMap(const T &t)
     {
       Base::_pred=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return DijkstraWizard<SetPredMapBase<T> >(*this);
+      return DijkstraWizard<DefPredMapBase<T> >(*this);
     }
 
     template<class T>
-    struct SetDistMapBase : public Base {
+    struct DefDistMapBase : public Base {
       typedef T DistMap;
       static DistMap *createDistMap(const Digraph &) { return 0; };
-      SetDistMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting DistMap object.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for setting DistMap object.
+      DefDistMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting DistMap type
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting DistMap type
+    ///
     template<class T>
-    DijkstraWizard<SetDistMapBase<T> > distMap(const T &t)
+    DijkstraWizard<DefDistMapBase<T> > distMap(const T &t)
     {
       Base::_dist=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return DijkstraWizard<SetDistMapBase<T> >(*this);
-    }
-
-    template<class T>
-    struct SetProcessedMapBase : public Base {
-      typedef T ProcessedMap;
-      static ProcessedMap *createProcessedMap(const Digraph &) { return 0; };
-      SetProcessedMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting ProcessedMap object.
-    ///
-    /// \ref named-func-param "Named parameter"
-    ///for setting ProcessedMap object.
-    template<class T>
-    DijkstraWizard<SetProcessedMapBase<T> > processedMap(const T &t)
-    {
-      Base::_processed=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return DijkstraWizard<SetProcessedMapBase<T> >(*this);
-    }
-
-    template<class T>
-    struct SetPathBase : public Base {
-      typedef T Path;
-      SetPathBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for getting the shortest path to the target node.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for getting the shortest path to the target node.
-    template<class T>
-    DijkstraWizard<SetPathBase<T> > path(const T &t)
-    {
-      Base::_path=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return DijkstraWizard<SetPathBase<T> >(*this);
-    }
-
-    ///\brief \ref named-func-param "Named parameter"
-    ///for getting the distance of the target node.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for getting the distance of the target node.
-    DijkstraWizard dist(const Value &d)
-    {
-      Base::_di=reinterpret_cast<void*>(const_cast<Value*>(&d));
+      return DijkstraWizard<DefDistMapBase<T> >(*this);
+    }
+
+    /// Sets the source node, from which the Dijkstra algorithm runs.
+
+    /// Sets the source node, from which the Dijkstra algorithm runs.
+    /// \param s is the source node.
+    DijkstraWizard<TR> &source(Node s)
+    {
+      Base::_source=s;
       return *this;
     }
@@ -1276,18 +1182,16 @@
   };
 
-  ///Function-type interface for Dijkstra algorithm.
+  ///Function type interface for Dijkstra algorithm.
 
   /// \ingroup shortest_path
-  ///Function-type interface for Dijkstra algorithm.
+  ///Function type interface for Dijkstra algorithm.
   ///
-  ///This function also has several \ref named-func-param "named parameters",
+  ///This function also has several
+  ///\ref named-templ-func-param "named parameters",
   ///they are declared as the members of class \ref DijkstraWizard.
-  ///The following examples show how to use these parameters.
+  ///The following
+  ///example shows how to use these parameters.
   ///\code
-  ///  // Compute shortest path from node s to each node
-  ///  dijkstra(g,length).predMap(preds).distMap(dists).run(s);
-  ///
-  ///  // Compute shortest path from s to t
-  ///  bool reached = dijkstra(g,length).path(p).dist(d).run(s,t);
+  ///  dijkstra(g,length,source).predMap(preds).run();
   ///\endcode
   ///\warning Don't forget to put the \ref DijkstraWizard::run() "run()"
@@ -1297,7 +1201,7 @@
   template<class GR, class LM>
   DijkstraWizard<DijkstraWizardBase<GR,LM> >
-  dijkstra(const GR &digraph, const LM &length)
+  dijkstra(const GR &g,const LM &l,typename GR::Node s=INVALID)
   {
-    return DijkstraWizard<DijkstraWizardBase<GR,LM> >(digraph,length);
+    return DijkstraWizard<DijkstraWizardBase<GR,LM> >(g,l,s);
   }
 
